(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/UList.sml,v
   Comment: Modelling notupdatable memory arrays of unique elements with lists
   Release: scope-0-10

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  UList.sml,v 1.6 2002/10/24 20:17:10 wasowski Exp
*)
  exception NotFound

  type ''a ulist = (''a * int) list * (''a -> int)

  fun initialize sizer = ([],sizer)

  fun size [] :int = 0
    | size ((x,s)::xs) = s

  fun length ((lst,sizer) :''a ulist) :int = size lst

  fun alloc (e :''a, (lst,sizer) :''a ulist) : int * ''a ulist = 
	let fun f [] = (size lst,((e,sizer e+size lst)::lst,sizer))
              | f ((x,s)::xs) = if e = x then (size xs,(lst,sizer)) else f xs 
	in f lst end

  fun find (e :''a, (lst,size) :''a ulist) : int =
	let fun f []       = raise NotFound
	      | f (he::ta) = if #1 he = e then #2 he else f ta
	in f lst end

  fun toList (xs :''a ulist) :''a list = map #1 (#1 xs)

  fun null ([],size) = true
    | null _         = false

    


